colors = {}

-- 	[0] 	[1] 	[2] 	[3] 	[4] 	[5] 	[6] 	
-- 	empty 	grass 	mud 	leaf 	stone 	water 	wood

colors[0] = {0x00, 0x00, 0x00, 0x00}
colors[1] = {0x50, 0x40, 0x60}
colors[2] = {0x20, 0x40, 0x60}
colors[3] = {0x60, 0x40, 0x50}
colors[4] = {0xA0, 0x00, 0x50}
colors[5] = {0x9C, 0x40, 0x60, 0xC0}
colors[6] = {0x30, 0x30, 0x40}

colors.sky = {0x90, 0x20, 0x80}
colors.player = {0x00, 0x00, 0x80, 0x80}

function hsl(h, s, l)

	if s < 0 then return l, l, l end

	if l < 0x00 then return 0x00, 0x00, 0x00 end
	if l > 0xFF then return 0xFF, 0xFF, 0xFF end

	h = h/0x100 * 6
	s = s/0x100
	l = l/0x100
	
	h = h > 0 and h < 6 and h or h % 6
	s = s > 1 and 1 or s

	local c =
	s * (1 - math.abs(2 * l - 1))
	
	local x =
	c * (1 - math.abs(h % 2 - 1))
	
	local r =
	h < 1 and c or
	h < 2 and x or
	h < 4 and 0 or
	h < 5 and x or c
	
	local g =
	h < 1 and x or
	h < 3 and c or
	h < 4 and x or 0
		
	local b =
	h < 2 and 0 or
	h < 3 and x or
	h < 5 and c or x
	
	local m = l - c/2
	
	return
	
	0xFF * (r + m),
	0xFF * (g + m),
	0xFF * (b + m)
end

function face_setColor(id, angle, dist)
		
	local h, s, l, a = unpack(colors[id])

	-- shadows
	l = angle and l * (1 - angle/0x6) or l

	-- field of view
	l = dist and l * (1 - dist/0xE) or l
	
	-- water light rounding
	l = id == 5 and math.floor(l/0xC) * 0xC or l

	local r, g, b = hsl(h, s, l)

	gr.setColor(r, g, b, a)
end
