function block_draw(gx, gy, gz, v)
		
	v = player_check(gx, gy, gz) and "player" or v

	if v == 0 then return end

	local
	x1, y1, x2, y2, x3, y3, x4, y4,
	x5, y5, x6, y6, x7, y7, x8, y8 =
	block_getVertices(gx, gy, gz)
	
	if onScreen(x1, y2, x3, y8) then
		
		local dist, angle, id = switch_lights and 0
		
		-- values in front of v
		local v_fx = block_getId(gx + 1, gy, gz)
		local v_fy = block_getId(gx, gy + 1, gz)
		local v_fz = block_getId(gx, gy, gz + 1)


		-- water level
		if v == 5 and v_fz == 0 then
		
			local z = tile_z
			
			y5, y6 = y5 + z, y6 + z
			y7, y8 = y7 + z, y8 + z

			local z = tile_z/8
			
			--waves == 1 or 0
			if (gx % 2 + gy % 2) % 2 ==
			math.floor(love.timer.getTime()*2%2) then
			
				y5 = y5 - z
				y7 = y7 - z
				
				y6 = y6 + z
				y8 = y8 + z
			
			else
				y5 = y5 + z
				y7 = y7 + z
				
				y6 = y6 - z
				y8 = y8 - z
			
			end
		end
		
		if block_getTransp(v) then
		
			-- values behind v
			local v_bx = block_getId(gx - 1, gy, gz)
			local v_by = block_getId(gx, gy - 1, gz)
			local v_bz = block_getId(gx, gy, gz - 1)
			
			--back right
			if v_bx ~= v then
			
				id, angle = v, -1
				dist = dist or getDist(gx, gy, gz)
				
				face_setColor(id, angle, dist)
				face_draw(x3, y3, x4, y4, x8, y8, x7, y7)
			end

			--back left
			if v_by ~= v then

				id, angle = v, 1
				dist = dist or getDist(gx, gy, gz)
				
				face_setColor(id, angle, dist)
				face_draw(x4, y4, x1, y1, x5, y5, x8, y8)
			end
			
			--back bottom
			if v_bz ~= v then
			
				id, angle = v
				dist = dist or getDist(gx, gy, gz)
				
				face_setColor(id, angle, dist)			
				face_draw(x1, y1, x2, y2, x3, y3, x4, y4)
			end
		end
				
		--front right
		if v_fx ~= v and block_getTransp(v_fx) then
			
			id, angle = v, 1
			dist = dist or getDist(gx, gy, gz)
				
			face_setColor(id, angle, dist)
			face_draw(x1, y1, x2, y2, x6, y6, x5, y5)
		end
		
		--front left		
		if v_fy ~= v and block_getTransp(v_fy) then
		
			id, angle = v, -1
			dist = dist or getDist(gx, gy, gz)
				
			face_setColor(id, angle, dist)
			face_draw(x2, y2, x3, y3, x7, y7, x6, y6)
		end
		
		--front up, surface		
		if v_fz ~= v and block_getTransp(v_fz) then
		
			id, angle = v
			dist = dist or getDist(gx, gy, gz)
				
			-- sow grass
			if v == 2 and v_fz == 0 then id = 1 end
			
			face_setColor(id, angle, dist)
			face_draw(x5, y5, x6, y6, x7, y7, x8, y8)
		end
	end
end

function face_draw(xa, ya, xb, yb, xc, yc, xd, yd)

	gr.quad("fill", xa, ya, xb, yb, xc, yc, xd, yd)

	if switch_line then
	
		gr.setColor(0xFF, 0xFF, 0xFF, 0x20)
		gr.setLineWidth(zoom)
		gr.quad("line", xa, ya, xb, yb, xc, yc, xd, yd)
	end
end
