base_w = 0x18 --* math.sqrt(3)/2
base_h = 0xC
base_z = 0xC

function engine_init()

	gr.setBackgroundColor(hsl(unpack(colors.sky)))
	
	gr.setFont(gr.newFont(16))

	input_init()
		
	getW = gr.getWidth()
	getH = gr.getHeight()

	tile_update()		
end

function engine_run()

	for gz in ipairs(map) do
		
		for gy in ipairs(map[gz]) do

			for gx, v in pairs(map[gz][gy]) do
				
				block_draw(gx, gy, gz, v)
			end
		end
	end
end

function tile_update()

	zoom = zoom or 1

	factor_w = factor_w or 1
	factor_h = factor_h or 1
	factor_z = factor_z or 1

	tile_w = base_w * factor_w * zoom
	tile_h = base_h * factor_h * zoom
	tile_z = base_z * factor_z * zoom
end

function camera_rotate(d, dt)

	factor_w = factor_w + d * dt
	factor_h = factor_h + d * dt * 4
	factor_z = factor_z - d * dt / 4
	
	tile_update()
end

function camera_zoom(d, dt)

	zoom = zoom * (1 + d * dt)
	
	tile_update()
end

function rhombus(x, y)

	return
	
	x + tile_w, y + tile_z,
	x, y + tile_h + tile_z,
	x - tile_w, y + tile_z,
	x, y - tile_h + tile_z,
	
	x + tile_w, y - tile_z,
	x, y + tile_h - tile_z,
	x - tile_w, y - tile_z,
	x, y - tile_h - tile_z
end

function axono(x, y, z)

	return

	(x - y) * tile_w,
	(x + y) * tile_h - (z + z) * tile_z
end

function block_getId(gx, gy, gz)

	return
	
	map[gz] and
	map[gz][gy] and
	map[gz][gy][gx]
end

function block_getTransp(v)

	return not v or colors[v][4]
end

function offset(x, y)

	local dx, dy = axono(

		player_gx,
		player_gy,
		player_gz
	)
	
	return

	x + getW/2 - dx,
	y + getH/2 - dy
end

function block_getVertices(x, y, z)

	return rhombus(offset(axono(x, y, z)))
end

function onScreen(xa, ya, xb, yb)

	return

	xa > 0 and xb < getW and
	ya > 0 and yb < getH
end

function getDist(x, y, z)

	local dx, dy, dz =
	player_gx - x,
	player_gy - y,
	player_gz - z
	
	return math.sqrt(
	
		dx * dx +
		dy * dy +
		dz * dz
	)
end
